package com.wall.photography.wallpapers;

import android.app.Application;
import android.content.Context;
import android.graphics.Typeface;
import android.util.Log;

import com.anythink.core.api.ATSDK;
import com.anythink.core.api.NetTrafficeCallback;
import com.wall.photography.wallpapers.mybean.MyData;
import com.wall.photography.wallpapers.tool.ComUtils;
import com.wall.photography.wallpapers.tool.JsonData;
import com.wall.photography.wallpapers.tool.ObectBoxManager;
import com.wall.photography.wallpapers.topon.AdManager;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class MyApp extends Application {
    public static Context mAppContext;

    public static String TAG = "-------MyApp---------";
    public static Typeface defaultFont;


    private String animasName = "Animals.json";
    private String exName = "Experimental.json";
    private String filmName = "Film.json";
    private String natureName = "Nature.json";
    private String pattName = "Patterns.json";
    private String streetName = "Street.json";
    private String travelName = "Travel.json";
    private String wallpaperName = "Featured.json";
    private ExecutorService executor;
    private static List<String> CategoryNames = new ArrayList<>();
    private int i = 0;

    @Override
    public void onCreate() {
        super.onCreate();
        mAppContext = this;
        defaultFont = Typeface.createFromAsset(getAssets(), "custfont.ttf");
        initTop();
        ObectBoxManager.init(this);
        executor = Executors.newFixedThreadPool(8);
        String[] names = {wallpaperName, animasName, exName, filmName, natureName, pattName, streetName, travelName};

        try {
            for (String name : names) {
                InputStream open = getAssets().open(name);
                String covertStr = ComUtils.getCovertStr(open);
                if (!covertStr.isEmpty()) {
                    String realName = name.substring(0, name.indexOf("."));
                    CategoryNames.add(realName);
                    executor.execute(new Runnable() {
                        @Override
                        public void run() {
                            i++;
                            Log.d(MyApp.TAG, "------------111");
                            List<MyData> data = JsonData.INSTANCE.getData(covertStr, realName);
                            Collections.shuffle(data);
                            for (MyData data1 : data) {
                                ObectBoxManager.addData(data1);
                            }

//                            if (i == 8) {
//                                executor.shutdown();
//                                Log.d(MyWallpaper.TAG, "------------data complete");
//                            }

                        }
                    });
                }
            }


        } catch (IOException e) {
            throw new RuntimeException(e);
        }


    }

    public static List<String> getCategoryNames() {
        return CategoryNames;
    }


    private void initTop() {
        ATSDK.checkIsEuTraffic(this, new NetTrafficeCallback() {

            @Override
            public void onResultCallback(boolean isEU) {

                if (isEU && ATSDK.getGDPRDataLevel(MyApp.mAppContext) == ATSDK.UNKNOWN) {
                    ATSDK.showGdprAuth(MyApp.mAppContext);
                }

            }

            @Override
            public void onErrorCallback(String errorMsg) {

            }
        });
        String APPId = "h68352a758b9e9";
        String AppKey = "a6bd26922633cc061107765957e22a287";
        ATSDK.init(this, APPId, AppKey);
        //测试工具
//        ATDebuggerUITest.showDebuggerUI(this,"d0a434af69020f58cd1c246da4adb0630eb18a02");
        AdManager.loadAllAd();

    }
}
